Index: trunk/sources/HeuristicLab.CEDMA.Charting/BubbleChart.cs
===================================================================
--- trunk/sources/HeuristicLab.CEDMA.Charting/BubbleChart.cs	(revision 1286)
+++ trunk/sources/HeuristicLab.CEDMA.Charting/BubbleChart.cs	(revision 1287)
@@ -27,7 +27,13 @@
 using HeuristicLab.Charting;
 using System.Windows.Forms;
+using HeuristicLab.CEDMA.Core;
+using HeuristicLab.PluginInfrastructure;
+using HeuristicLab.Core;
+using HeuristicLab.CEDMA.DB.Interfaces;
 
 namespace HeuristicLab.CEDMA.Charting {
   public class BubbleChart : Chart {
+    private const string X_JITTER = "__X_JITTER";
+    private const string Y_JITTER = "__Y_JITTER";
     private const double maxXJitterPercent = 0.05;
     private const double maxYJitterPercent = 0.05;
@@ -49,21 +55,26 @@
     private double maxX = double.NegativeInfinity;
     private double maxY = double.NegativeInfinity;
-    private List<Record> records;
-    private ResultList results;
-    private Dictionary<IPrimitive, Record> primitiveToRecordDictionary;
-    private Dictionary<Record, IPrimitive> recordToPrimitiveDictionary;
+    private List<ResultsEntry> records;
+    private Results results;
+    private Dictionary<IPrimitive, ResultsEntry> primitiveToEntryDictionary;
+    private Dictionary<ResultsEntry, IPrimitive> entryToPrimitiveDictionary;
     private Random random = new Random();
     private Group points;
 
-    public BubbleChart(ResultList results, PointD lowerLeft, PointD upperRight)
+    public BubbleChart(Results results, PointD lowerLeft, PointD upperRight)
       : base(lowerLeft, upperRight) {
-      records = new List<Record>();
-      primitiveToRecordDictionary = new Dictionary<IPrimitive, Record>();
-      recordToPrimitiveDictionary = new Dictionary<Record, IPrimitive>();
+      records = new List<ResultsEntry>();
+      primitiveToEntryDictionary = new Dictionary<IPrimitive, ResultsEntry>();
+      entryToPrimitiveDictionary = new Dictionary<ResultsEntry, IPrimitive>();
       this.results = results;
-      foreach(Record r in results.Records) {
-        records.Add(r);
-     }
-      results.OnRecordAdded += new EventHandler<RecordAddedEventArgs>(results_OnRecordAdded);
+
+      foreach (var resultsEntry in results.GetEntries()) {
+        if (resultsEntry.Get(X_JITTER) == null)
+          resultsEntry.Set(X_JITTER, random.NextDouble() * 2.0 - 1.0);
+        if (resultsEntry.Get(Y_JITTER) == null)
+          resultsEntry.Set(Y_JITTER, random.NextDouble() * 2.0 - 1.0);
+        records.Add(resultsEntry);
+      }
+
       results.Changed += new EventHandler(results_Changed);
     }
@@ -74,12 +85,6 @@
     }
 
-    public BubbleChart(ResultList results, double x1, double y1, double x2, double y2)
+    public BubbleChart(Results results, double x1, double y1, double x2, double y2)
       : this(results, new PointD(x1, y1), new PointD(x2, y2)) {
-    }
-
-    void results_OnRecordAdded(object sender, RecordAddedEventArgs e) {
-      lock(records) {
-        records.Add(e.Record);
-      }
     }
 
@@ -92,7 +97,8 @@
 
     public void ShowXvsY(string xDimension, string yDimension) {
-      if(this.xDimension != xDimension || this.yDimension != yDimension) {
+      if (this.xDimension != xDimension || this.yDimension != yDimension) {
         this.xDimension = xDimension;
         this.yDimension = yDimension;
+
         ResetViewSize();
         Repaint();
@@ -109,51 +115,67 @@
 
     private void Repaint() {
-      if(xDimension == null || yDimension == null) return;
-      lock(records) {
-        double maxSize = 1;
-        double minSize = 1;
-        if(sizeDimension != null) {
-          var sizes = records.Select(r => r.Get(sizeDimension)).Where(x => !double.IsInfinity(x) && x != double.MaxValue && x != double.MinValue).OrderBy(x=>x);
+      if (xDimension == null || yDimension == null) return;
+      double maxSize = 1;
+      double minSize = 1;
+      try {
+        if (sizeDimension != null && results.OrdinalVariables.Contains(sizeDimension)) {
+          var sizes = records
+            .Select(x => Convert.ToDouble(x.Get(sizeDimension)))
+            .Where(size => !double.IsInfinity(size) && size != double.MaxValue && size != double.MinValue)
+            .OrderBy(r => r);
           minSize = sizes.ElementAt((int)(sizes.Count() * 0.1));
           maxSize = sizes.ElementAt((int)(sizes.Count() * 0.9));
         }
-        UpdateEnabled = false;
-        Group.Clear();
-        primitiveToRecordDictionary.Clear();
-        recordToPrimitiveDictionary.Clear();
-        points = new Group(this);
-        Group.Add(new Axis(this, 0, 0, AxisType.Both));
-        UpdateViewSize(0, 0, 5);
-        foreach(Record r in records) {
-          double x = r.Get(xDimension) + r.Get(Record.X_JITTER) * xJitterFactor;
-          double y = r.Get(yDimension) + r.Get(Record.Y_JITTER) * yJitterFactor;
-          int size = CalculateSize(r.Get(sizeDimension), minSize, maxSize);
-
-          if(double.IsInfinity(x) || x == double.MaxValue || x == double.MinValue) x = double.NaN;
-          if(double.IsInfinity(y) || y == double.MaxValue || y == double.MinValue) y = double.NaN;
-          if(!double.IsNaN(x) && !double.IsNaN(y)) {
-            UpdateViewSize(x, y, size);
-            int alpha = CalculateAlpha(size);
-            Pen pen = new Pen(Color.FromArgb(alpha, r.Selected ? selectionColor : defaultColor));
-            Brush brush = pen.Brush;
-            FixedSizeCircle c = new FixedSizeCircle(this, x, y, size, pen, brush);
-            c.ToolTipText = r.GetToolTipText();
-            points.Add(c);
-            if(!r.Selected) c.IntoBackground();
-            primitiveToRecordDictionary[c] = r;
-            recordToPrimitiveDictionary[r] = c;
-          }
-        }
-        Group.Add(points);
-        UpdateEnabled = true;
-      }
+      }
+      catch (InvalidCastException) {
+        minSize = 1;
+        maxSize = 1;
+      }
+      UpdateEnabled = false;
+      Group.Clear();
+      primitiveToEntryDictionary.Clear();
+      entryToPrimitiveDictionary.Clear();
+      points = new Group(this);
+      Group.Add(new Axis(this, 0, 0, AxisType.Both));
+      UpdateViewSize(0, 0, 5);
+      foreach (ResultsEntry r in records) {
+        double x, y;
+        int size;
+        try {
+          x = Convert.ToDouble(r.Get(xDimension)) + (double)r.Get(X_JITTER) * xJitterFactor;
+          y = Convert.ToDouble(r.Get(yDimension)) + (double)r.Get(Y_JITTER) * yJitterFactor;
+          size = CalculateSize(Convert.ToDouble(r.Get(sizeDimension)), minSize, maxSize);
+        }
+        catch (InvalidCastException) {
+          x = double.NaN;
+          y = double.NaN;
+          size = minBubbleSize;
+        }
+        if (double.IsInfinity(x) || x == double.MaxValue || x == double.MinValue) x = double.NaN;
+        if (double.IsInfinity(y) || y == double.MaxValue || y == double.MinValue) y = double.NaN;
+        if (!double.IsNaN(x) && !double.IsNaN(y)) {
+          UpdateViewSize(x, y, size);
+          int alpha = CalculateAlpha(size);
+          Pen pen = new Pen(Color.FromArgb(alpha, r.Selected ? selectionColor : defaultColor));
+          Brush brush = pen.Brush;
+          FixedSizeCircle c = new FixedSizeCircle(this, x, y, size, pen, brush);
+          c.ToolTipText = r.GetToolTipText();
+          points.Add(c);
+          if (!r.Selected) c.IntoBackground();
+          primitiveToEntryDictionary[c] = r;
+          entryToPrimitiveDictionary[r] = c;
+        }
+      }
+      Group.Add(points);
+      UpdateEnabled = true;
     }
 
     private int CalculateSize(double size, double minSize, double maxSize) {
-      if(double.IsNaN(size) || double.IsInfinity(size) || size == double.MaxValue || size == double.MinValue) return minBubbleSize;
-      if(size > maxSize) size = maxSize;
-      if(size < minSize) size = minSize;
+      if (double.IsNaN(size) || double.IsInfinity(size) || size == double.MaxValue || size == double.MinValue) return minBubbleSize;
+      if (size > maxSize) size = maxSize;
+      if (size < minSize) size = minSize;
+      if (Math.Abs(maxSize - minSize) < 1.0E-10) return minBubbleSize;
       double sizeDifference = ((size - minSize) / (maxSize - minSize) * (maxBubbleSize - minBubbleSize));
-      if(invertSize) return maxBubbleSize - (int)sizeDifference;
+      if (invertSize) return maxBubbleSize - (int)sizeDifference;
       else return minBubbleSize + (int)sizeDifference;
     }
@@ -164,5 +186,5 @@
 
     private void ZoomToViewSize() {
-      if(minX < maxX && minY < maxY) {
+      if (minX < maxX && minY < maxY) {
         // enlarge view by 5% on each side
         double width = maxX - minX;
@@ -177,8 +199,8 @@
 
     private void UpdateViewSize(double x, double y, double size) {
-      if(x - size < minX) minX = x - size;
-      if(x + size > maxX) maxX = x + size;
-      if(y - size < minY) minY = y + size;
-      if(y + size > maxY) maxY = y + size;
+      if (x - size < minX) minX = x - size;
+      if (x + size > maxX) maxX = x + size;
+      if (y - size < minY) minY = y + size;
+      if (y + size > maxY) maxY = y + size;
     }
 
@@ -190,9 +212,9 @@
     }
 
-    internal Record GetRecord(Point point) {
-      Record r = null;
+    internal ResultsEntry GetResultsEntry(Point point) {
+      ResultsEntry r = null;
       IPrimitive p = points.GetPrimitive(TransformPixelToWorld(point));
-      if(p != null) {
-        primitiveToRecordDictionary.TryGetValue(p, out r);
+      if (p != null) {
+        primitiveToEntryDictionary.TryGetValue(p, out r);
       }
       return r;
@@ -201,5 +223,5 @@
 
     public override void MouseDrag(Point start, Point end, MouseButtons button) {
-      if(button == MouseButtons.Left && Mode == ChartMode.Select) {
+      if (button == MouseButtons.Left && Mode == ChartMode.Select) {
         PointD a = TransformPixelToWorld(start);
         PointD b = TransformPixelToWorld(end);
@@ -213,12 +235,12 @@
         primitives.AddRange(points.Primitives);
 
-        foreach(FixedSizeCircle p in primitives) {
-          if(rect.ContainsPoint(p.Point)) {
-            Record r;
-            primitiveToRecordDictionary.TryGetValue(p, out r);
-            if(r != null) r.ToggleSelected();
+        foreach (FixedSizeCircle p in primitives) {
+          if (rect.ContainsPoint(p.Point)) {
+            ResultsEntry r;
+            primitiveToEntryDictionary.TryGetValue(p, out r);
+            if (r != null) r.ToggleSelected();
           }
         }
-        results.FireChanged();
+        if (primitives.Count() > 0) results.FireChanged();
       } else {
         base.MouseDrag(start, end, button);
@@ -227,7 +249,7 @@
 
     public override void MouseClick(Point point, MouseButtons button) {
-      if(button == MouseButtons.Left) {
-        Record r = GetRecord(point);
-        if(r != null) r.ToggleSelected();
+      if (button == MouseButtons.Left) {
+        ResultsEntry r = GetResultsEntry(point);
+        if (r != null) r.ToggleSelected();
         results.FireChanged();
       } else {
@@ -237,7 +259,11 @@
 
     public override void MouseDoubleClick(Point point, MouseButtons button) {
-      if(button == MouseButtons.Left) {
-        Record r = GetRecord(point);
-        if(r != null) r.OpenModel();
+      if (button == MouseButtons.Left) {
+        ResultsEntry entry = GetResultsEntry(point);
+        if (entry != null) {
+          string serializedData = (string)entry.Get(Ontology.PredicateSerializedData.Uri.Replace(Ontology.CedmaNameSpace, ""));
+          var model = (IItem)PersistenceManager.RestoreFromGZip(Convert.FromBase64String(serializedData));
+          PluginManager.ControlManager.ShowControl(model.CreateView());
+        }
       } else {
         base.MouseDoubleClick(point, button);
Index: trunk/sources/HeuristicLab.CEDMA.Charting/BubbleChartView.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.CEDMA.Charting/BubbleChartView.Designer.cs	(revision 1287)
+++ trunk/sources/HeuristicLab.CEDMA.Charting/BubbleChartView.Designer.cs	(revision 1287)
@@ -0,0 +1,206 @@
+﻿namespace HeuristicLab.CEDMA.Charting {
+  partial class BubbleChartView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if(disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.yJitterLabel = new System.Windows.Forms.Label();
+      this.xJitterlabel = new System.Windows.Forms.Label();
+      this.xTrackBar = new System.Windows.Forms.TrackBar();
+      this.xAxisLabel = new System.Windows.Forms.Label();
+      this.xAxisComboBox = new System.Windows.Forms.ComboBox();
+      this.yAxisLabel = new System.Windows.Forms.Label();
+      this.yAxisComboBox = new System.Windows.Forms.ComboBox();
+      this.yTrackBar = new System.Windows.Forms.TrackBar();
+      this.sizeComboBox = new System.Windows.Forms.ComboBox();
+      this.sizeLabel = new System.Windows.Forms.Label();
+      this.invertCheckbox = new System.Windows.Forms.CheckBox();
+      this.bubbleChartControl = new HeuristicLab.CEDMA.Charting.BubbleChartControl();
+      ((System.ComponentModel.ISupportInitialize)(this.xTrackBar)).BeginInit();
+      ((System.ComponentModel.ISupportInitialize)(this.yTrackBar)).BeginInit();
+      this.SuspendLayout();
+      // 
+      // yJitterLabel
+      // 
+      this.yJitterLabel.AutoSize = true;
+      this.yJitterLabel.Location = new System.Drawing.Point(3, 30);
+      this.yJitterLabel.Name = "yJitterLabel";
+      this.yJitterLabel.Size = new System.Drawing.Size(29, 13);
+      this.yJitterLabel.TabIndex = 13;
+      this.yJitterLabel.Text = "jitter:";
+      // 
+      // xJitterlabel
+      // 
+      this.xJitterlabel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
+      this.xJitterlabel.AutoSize = true;
+      this.xJitterlabel.Location = new System.Drawing.Point(291, 418);
+      this.xJitterlabel.Name = "xJitterlabel";
+      this.xJitterlabel.Size = new System.Drawing.Size(29, 13);
+      this.xJitterlabel.TabIndex = 12;
+      this.xJitterlabel.Text = "jitter:";
+      // 
+      // xTrackBar
+      // 
+      this.xTrackBar.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
+      this.xTrackBar.Location = new System.Drawing.Point(326, 418);
+      this.xTrackBar.Maximum = 100;
+      this.xTrackBar.Name = "xTrackBar";
+      this.xTrackBar.Size = new System.Drawing.Size(121, 45);
+      this.xTrackBar.TabIndex = 11;
+      this.xTrackBar.TickStyle = System.Windows.Forms.TickStyle.None;
+      this.xTrackBar.ValueChanged += new System.EventHandler(this.jitterTrackBar_ValueChanged);
+      // 
+      // xAxisLabel
+      // 
+      this.xAxisLabel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
+      this.xAxisLabel.AutoSize = true;
+      this.xAxisLabel.Location = new System.Drawing.Point(305, 394);
+      this.xAxisLabel.Name = "xAxisLabel";
+      this.xAxisLabel.Size = new System.Drawing.Size(15, 13);
+      this.xAxisLabel.TabIndex = 8;
+      this.xAxisLabel.Text = "x:";
+      // 
+      // xAxisComboBox
+      // 
+      this.xAxisComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
+      this.xAxisComboBox.FormattingEnabled = true;
+      this.xAxisComboBox.Location = new System.Drawing.Point(326, 391);
+      this.xAxisComboBox.Name = "xAxisComboBox";
+      this.xAxisComboBox.Size = new System.Drawing.Size(121, 21);
+      this.xAxisComboBox.TabIndex = 7;
+      this.xAxisComboBox.SelectedIndexChanged += new System.EventHandler(this.axisComboBox_SelectedIndexChanged);
+      // 
+      // yAxisLabel
+      // 
+      this.yAxisLabel.AutoSize = true;
+      this.yAxisLabel.Location = new System.Drawing.Point(3, 6);
+      this.yAxisLabel.Name = "yAxisLabel";
+      this.yAxisLabel.Size = new System.Drawing.Size(15, 13);
+      this.yAxisLabel.TabIndex = 6;
+      this.yAxisLabel.Text = "y:";
+      // 
+      // yAxisComboBox
+      // 
+      this.yAxisComboBox.FormattingEnabled = true;
+      this.yAxisComboBox.Location = new System.Drawing.Point(24, 3);
+      this.yAxisComboBox.Name = "yAxisComboBox";
+      this.yAxisComboBox.Size = new System.Drawing.Size(121, 21);
+      this.yAxisComboBox.TabIndex = 5;
+      this.yAxisComboBox.SelectedIndexChanged += new System.EventHandler(this.axisComboBox_SelectedIndexChanged);
+      // 
+      // yTrackBar
+      // 
+      this.yTrackBar.Location = new System.Drawing.Point(38, 30);
+      this.yTrackBar.Maximum = 100;
+      this.yTrackBar.Name = "yTrackBar";
+      this.yTrackBar.Size = new System.Drawing.Size(107, 45);
+      this.yTrackBar.TabIndex = 10;
+      this.yTrackBar.TickStyle = System.Windows.Forms.TickStyle.None;
+      this.yTrackBar.ValueChanged += new System.EventHandler(this.jitterTrackBar_ValueChanged);
+      // 
+      // sizeComboBox
+      // 
+      this.sizeComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
+      this.sizeComboBox.FormattingEnabled = true;
+      this.sizeComboBox.Location = new System.Drawing.Point(329, 3);
+      this.sizeComboBox.Name = "sizeComboBox";
+      this.sizeComboBox.Size = new System.Drawing.Size(121, 21);
+      this.sizeComboBox.TabIndex = 14;
+      this.sizeComboBox.SelectedIndexChanged += new System.EventHandler(this.sizeComboBox_SelectedIndexChanged);
+      // 
+      // sizeLabel
+      // 
+      this.sizeLabel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
+      this.sizeLabel.AutoSize = true;
+      this.sizeLabel.Location = new System.Drawing.Point(259, 6);
+      this.sizeLabel.Name = "sizeLabel";
+      this.sizeLabel.Size = new System.Drawing.Size(64, 13);
+      this.sizeLabel.TabIndex = 15;
+      this.sizeLabel.Text = "Bubble size:";
+      // 
+      // invertCheckbox
+      // 
+      this.invertCheckbox.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
+      this.invertCheckbox.AutoSize = true;
+      this.invertCheckbox.CheckAlign = System.Drawing.ContentAlignment.MiddleRight;
+      this.invertCheckbox.Location = new System.Drawing.Point(326, 30);
+      this.invertCheckbox.Name = "invertCheckbox";
+      this.invertCheckbox.Size = new System.Drawing.Size(64, 17);
+      this.invertCheckbox.TabIndex = 16;
+      this.invertCheckbox.Text = "Inverse:";
+      this.invertCheckbox.UseVisualStyleBackColor = true;
+      this.invertCheckbox.CheckedChanged += new System.EventHandler(this.sizeComboBox_SelectedIndexChanged);
+      // 
+      // bubbleChartControl
+      // 
+      this.bubbleChartControl.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+                  | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.bubbleChartControl.BackColor = System.Drawing.SystemColors.Control;
+      this.bubbleChartControl.Chart = null;
+      this.bubbleChartControl.Location = new System.Drawing.Point(3, 81);
+      this.bubbleChartControl.Name = "bubbleChartControl";
+      this.bubbleChartControl.ScaleOnResize = true;
+      this.bubbleChartControl.Size = new System.Drawing.Size(444, 304);
+      this.bubbleChartControl.TabIndex = 17;
+      // 
+      // BubbleChartView
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.bubbleChartControl);
+      this.Controls.Add(this.invertCheckbox);
+      this.Controls.Add(this.sizeLabel);
+      this.Controls.Add(this.sizeComboBox);
+      this.Controls.Add(this.yJitterLabel);
+      this.Controls.Add(this.xJitterlabel);
+      this.Controls.Add(this.xTrackBar);
+      this.Controls.Add(this.xAxisLabel);
+      this.Controls.Add(this.xAxisComboBox);
+      this.Controls.Add(this.yAxisLabel);
+      this.Controls.Add(this.yAxisComboBox);
+      this.Controls.Add(this.yTrackBar);
+      this.Name = "BubbleChartView";
+      this.Size = new System.Drawing.Size(450, 459);
+      ((System.ComponentModel.ISupportInitialize)(this.xTrackBar)).EndInit();
+      ((System.ComponentModel.ISupportInitialize)(this.yTrackBar)).EndInit();
+      this.ResumeLayout(false);
+      this.PerformLayout();
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.Label xAxisLabel;
+    private System.Windows.Forms.ComboBox xAxisComboBox;
+    private System.Windows.Forms.Label yAxisLabel;
+    private System.Windows.Forms.ComboBox yAxisComboBox;
+    private System.Windows.Forms.TrackBar yTrackBar;
+    private System.Windows.Forms.TrackBar xTrackBar;
+    private System.Windows.Forms.Label xJitterlabel;
+    private System.Windows.Forms.Label yJitterLabel;
+    private System.Windows.Forms.ComboBox sizeComboBox;
+    private System.Windows.Forms.Label sizeLabel;
+    private System.Windows.Forms.CheckBox invertCheckbox;
+    private BubbleChartControl bubbleChartControl;
+  }
+}
Index: trunk/sources/HeuristicLab.CEDMA.Charting/BubbleChartView.cs
===================================================================
--- trunk/sources/HeuristicLab.CEDMA.Charting/BubbleChartView.cs	(revision 1287)
+++ trunk/sources/HeuristicLab.CEDMA.Charting/BubbleChartView.cs	(revision 1287)
@@ -0,0 +1,72 @@
+﻿using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Drawing;
+using System.Data;
+using System.Linq;
+using System.Text;
+using System.Windows.Forms;
+using HeuristicLab.Core;
+using HeuristicLab.CEDMA.Charting;
+using HeuristicLab.CEDMA.Core;
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.CEDMA.Charting {
+  public class BubbleChartViewFactory : IResultsViewFactory {
+    #region IResultsViewFactory Members
+
+    public string Name {
+      get { return "Bubble chart"; }
+    }
+
+    public IControl CreateView(Results results) {
+      return new BubbleChartView(results);
+    }
+
+    #endregion
+  }
+
+  public partial class BubbleChartView : ViewBase {
+    private Results Results {
+      get { return (Results)Item; }
+      set { Item = value; }
+    }
+    private const string CONSTANT_SIZE = "<constant>";
+    private Label pleaseSelectAxisLabel = new Label();
+    public BubbleChartView(Results results) {
+      InitializeComponent();
+      Results = results;
+      bubbleChartControl.Chart = new BubbleChart(Results, 0, 0, 100, 100);
+      xAxisComboBox.Items.AddRange(Results.OrdinalVariables);
+      xAxisComboBox.Items.AddRange(Results.CategoricalVariables);
+      yAxisComboBox.Items.AddRange(Results.OrdinalVariables);
+      yAxisComboBox.Items.AddRange(Results.CategoricalVariables);
+      sizeComboBox.Items.Add(CONSTANT_SIZE);
+      sizeComboBox.Items.AddRange(Results.OrdinalVariables);
+      sizeComboBox.SelectedItem = sizeComboBox.Items[0];
+      yAxisComboBox.SelectedItem = yAxisComboBox.Items[0];
+      xAxisComboBox.SelectedItem = xAxisComboBox.Items[0];
+    }
+
+    private void axisComboBox_SelectedIndexChanged(object sender, EventArgs e) {
+      UpdateChart();
+    }
+
+    private void UpdateChart() {
+      if (xAxisComboBox.SelectedItem == null || yAxisComboBox.SelectedItem == null) return;
+      bubbleChartControl.Chart.ShowXvsY((string)xAxisComboBox.SelectedItem, (string)yAxisComboBox.SelectedItem);
+    }
+
+    private void jitterTrackBar_ValueChanged(object sender, EventArgs e) {
+      double xJitterFactor = xTrackBar.Value / 100.0;
+      double yJitterFactor = yTrackBar.Value / 100.0;
+      bubbleChartControl.Chart.SetJitter(xJitterFactor, yJitterFactor);
+      UpdateChart();
+    }
+
+    private void sizeComboBox_SelectedIndexChanged(object sender, EventArgs e) {
+      bubbleChartControl.Chart.SetBubbleSizeDimension((string)sizeComboBox.SelectedItem, invertCheckbox.Checked);
+      UpdateChart();
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.CEDMA.Charting/HeuristicLab.CEDMA.Charting.csproj
===================================================================
--- trunk/sources/HeuristicLab.CEDMA.Charting/HeuristicLab.CEDMA.Charting.csproj	(revision 1286)
+++ trunk/sources/HeuristicLab.CEDMA.Charting/HeuristicLab.CEDMA.Charting.csproj	(revision 1287)
@@ -73,29 +73,18 @@
       <DependentUpon>BubbleChartControl.cs</DependentUpon>
     </Compile>
-    <Compile Include="Histogram.cs" />
-    <Compile Include="HistogramControl.cs">
+    <Compile Include="BubbleChartView.cs">
       <SubType>UserControl</SubType>
     </Compile>
-    <Compile Include="HistogramControl.Designer.cs">
-      <DependentUpon>HistogramControl.cs</DependentUpon>
+    <Compile Include="BubbleChartView.Designer.cs">
+      <DependentUpon>BubbleChartView.cs</DependentUpon>
     </Compile>
-    <Compile Include="ModelView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="ModelView.Designer.cs">
-      <DependentUpon>ModelView.cs</DependentUpon>
-    </Compile>
-    <Compile Include="Record.cs" />
     <Compile Include="HeuristicLabCedmaChartingPlugin.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
-    <Compile Include="ResultList.cs" />
-    <Compile Include="ResultListView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="ResultListView.Designer.cs">
-      <DependentUpon>ResultListView.cs</DependentUpon>
-    </Compile>
   </ItemGroup>
   <ItemGroup>
+    <ProjectReference Include="..\HeuristicLab.CEDMA.Core\HeuristicLab.CEDMA.Core.csproj">
+      <Project>{C27DDF6C-84DF-45EF-B82F-57A28DD51166}</Project>
+      <Name>HeuristicLab.CEDMA.Core</Name>
+    </ProjectReference>
     <ProjectReference Include="..\HeuristicLab.CEDMA.DB.Interfaces\HeuristicLab.CEDMA.DB.Interfaces.csproj">
       <Project>{4F9BB789-D561-436B-B226-2BF44B7D0804}</Project>
@@ -122,12 +111,4 @@
       <Name>HeuristicLab.Data</Name>
     </ProjectReference>
-    <ProjectReference Include="..\HeuristicLab.GP.StructureIdentification\HeuristicLab.GP.StructureIdentification.csproj">
-      <Project>{74223A32-C726-4978-BE78-37113A18373C}</Project>
-      <Name>HeuristicLab.GP.StructureIdentification</Name>
-    </ProjectReference>
-    <ProjectReference Include="..\HeuristicLab.GP\HeuristicLab.GP.csproj">
-      <Project>{1F1CF3ED-374C-4288-995B-93F6B872F571}</Project>
-      <Name>HeuristicLab.GP</Name>
-    </ProjectReference>
     <ProjectReference Include="..\HeuristicLab.Logging\HeuristicLab.Logging.csproj">
       <Project>{4095C92C-5A4C-44BC-9963-5F384CF5CC3F}</Project>
@@ -146,17 +127,7 @@
     <EmbeddedResource Include="BubbleChartControl.resx">
       <DependentUpon>BubbleChartControl.cs</DependentUpon>
-      <SubType>Designer</SubType>
     </EmbeddedResource>
-    <EmbeddedResource Include="HistogramControl.resx">
-      <DependentUpon>HistogramControl.cs</DependentUpon>
-      <SubType>Designer</SubType>
-    </EmbeddedResource>
-    <EmbeddedResource Include="ModelView.resx">
-      <DependentUpon>ModelView.cs</DependentUpon>
-      <SubType>Designer</SubType>
-    </EmbeddedResource>
-    <EmbeddedResource Include="ResultListView.resx">
-      <DependentUpon>ResultListView.cs</DependentUpon>
-      <SubType>Designer</SubType>
+    <EmbeddedResource Include="BubbleChartView.resx">
+      <DependentUpon>BubbleChartView.cs</DependentUpon>
     </EmbeddedResource>
   </ItemGroup>
Index: trunk/sources/HeuristicLab.CEDMA.Core/Console.cs
===================================================================
--- trunk/sources/HeuristicLab.CEDMA.Core/Console.cs	(revision 1286)
+++ trunk/sources/HeuristicLab.CEDMA.Core/Console.cs	(revision 1287)
@@ -29,13 +29,10 @@
 using System.ServiceModel.Description;
 using HeuristicLab.CEDMA.DB.Interfaces;
-using HeuristicLab.CEDMA.Charting;
 
 namespace HeuristicLab.CEDMA.Core {
   public class Console : ItemBase, IEditable {
-    private AgentList agentList;
-    private ResultList resultsList;
-    private DatabaseOperatorLibrary operatorLibary;
-    private ChannelFactory<IDatabase> factory;
-    private IDatabase database;
+    private DataSetList dataSetList;
+    private ChannelFactory<IStore> factory;
+    private IStore store;
     private string serverUri;
     public string ServerUri {
@@ -43,21 +40,11 @@
     }
 
-    public IAgentList AgentList {
-      get { return agentList; }
-    }
-
-    public ResultList ResultsList {
-      get { return resultsList; }
-    }
-
-    public IOperatorLibrary OperatorLibrary {
-      get { return operatorLibary; }
+    public DataSetList DataSetList {
+      get { return dataSetList; }
     }
 
     public Console()
       : base() {
-      agentList = new AgentList();
-      resultsList = new ResultList();
-      operatorLibary = new DatabaseOperatorLibrary();
+      dataSetList = new DataSetList();
     }
 
@@ -88,16 +75,11 @@
     private void ResetConnection() {
       NetTcpBinding binding = new NetTcpBinding();
-      binding.MaxReceivedMessageSize = 100000000; // 100Mbytes
-      binding.ReaderQuotas.MaxStringContentLength = 100000000; // also 100M chars
-      binding.ReaderQuotas.MaxArrayLength = 100000000; // also 100M elements;
-      binding.Security.Mode = SecurityMode.None;
-      factory = new ChannelFactory<IDatabase>(binding);
-      database = factory.CreateChannel(new EndpointAddress(serverUri));
-      agentList.Database = database;
-      operatorLibary.Database = database;
-
-      ChannelFactory<IStore> storeFactory = new ChannelFactory<IStore>(binding);
-      IStore store = storeFactory.CreateChannel(new EndpointAddress(serverUri + "/RdfStore"));
-      resultsList.Store = store;
+      binding.ReceiveTimeout = new TimeSpan(1, 0, 0);
+      binding.MaxReceivedMessageSize = 1000000000; // 100Mbytes
+      binding.ReaderQuotas.MaxStringContentLength = 1000000000; // also 100M chars
+      binding.ReaderQuotas.MaxArrayLength = 1000000000; // also 100M elements;
+      factory = new ChannelFactory<IStore>(binding);
+      store = factory.CreateChannel(new EndpointAddress(serverUri));
+      dataSetList.Store = store;
     }
     #endregion
